diff -Nru ./fluid/widget_panel.fl ../fltk-2-cvs/fluid/widget_panel.fl
--- ./fluid/widget_panel.fl	Tue Jan 23 20:47:54 2001
+++ ../fltk-2-cvs/fluid/widget_panel.fl	Tue Jul 10 20:00:12 2001
@@ -1,15 +1,15 @@
 # data file for the FLTK User Interface Designer (FLUID)
-version 2.0000 
+version 2.0001 
 images_dir ./ 
 header_name {.h} 
 code_name {.cxx} 
 gridx 5 
 gridy 5 
 snap 2
-Function {make_widget_panel()} {open
+Function {make_widget_panel()} {open selected
 } {
   Fl_Window {} {open
-    xywh {94 248 380 375} resizable hotspot visible
+    xywh {94 248 380 375} hide resizable hotspot
   } {
     Fl_Tabs panel_tabs {
       callback propagate_tabs open
@@ -18,23 +18,23 @@
       Fl_Group {} {
         label GUI
         callback propagate_group open
-        xywh {10 35 365 295} resizable
+        xywh {0 25 365 295} resizable
       } {
         Fl_Input {} {
           label {Label:}
           callback label_cb
           tooltip {Text displayed on or next to the widget}
-          xywh {90 45 275 25} when 1
+          xywh {80 10 275 25} when 1
         }
         Fl_Box image_label {
           label {Image:}
-          xywh {19 70 71 20} align 24
+          xywh {9 35 71 20} align 24
         }
         Fl_Button {} {
           label {Image name}
           callback image_cb
           tooltip {Select an image to label the widget}
-          xywh {90 70 195 25} align 524308
+          xywh {80 35 195 25} align 524308
           code0 {o->color(o->text_background());}
           code1 {o->box(o->text_box());}
         }
@@ -43,18 +43,18 @@
           callback image_inlined_cb
           tooltip {Include the datas of the image inlined in 
 the code or keep it in an external file}
-          xywh {285 70 80 25} align 524436 labelsize 10
+          xywh {275 35 80 25} align 524436 labelsize 10
         }
         Fl_Box {} {
           label {Alignment:}
-          xywh {20 100 70 20} align 24
+          xywh {10 65 70 20} align 24
         }
         Fl_Button {} {
           label tiled
           user_data FL_ALIGN_TILED
           callback align_cb
           tooltip {Draw the image tiled}
-          xywh {90 100 44 20} type Toggle
+          xywh {80 65 44 20} type Toggle
         }
         Fl_Button {} {
           label clip
@@ -62,170 +62,170 @@
           callback align_cb
           tooltip {Turn on clipping to the widget's area when drawing
 label.  This is slower so it should be left off if label will fit}
-          xywh {134 100 43 20} type Toggle
+          xywh {124 65 43 20} type Toggle
         }
         Fl_Button {} {
           label wrap
           user_data FL_ALIGN_WRAP
           callback align_cb
           tooltip {Word-wrap the label}
-          xywh {177 100 43 20} type Toggle
+          xywh {167 65 43 20} type Toggle
         }
         Fl_Button {} {
           label {@-1<-}
           user_data FL_ALIGN_LEFT
           callback align_cb
           tooltip {Places label on the left of the widget}
-          xywh {265 100 20 20} type Toggle labeltype SYMBOL_LABEL
+          xywh {255 65 20 20} type Toggle labeltype SYMBOL_LABEL
         }
         Fl_Button {} {
           label {@-1->}
           user_data FL_ALIGN_RIGHT
           callback align_cb
           tooltip {Places label on the right of the widget}
-          xywh {285 100 20 20} type Toggle labeltype SYMBOL_LABEL
+          xywh {275 65 20 20} type Toggle labeltype SYMBOL_LABEL
         }
         Fl_Button {} {
           label {@-18}
           user_data FL_ALIGN_TOP
           callback align_cb
           tooltip {Places label on the top of the widget}
-          xywh {305 100 20 20} type Toggle labeltype SYMBOL_LABEL
+          xywh {295 65 20 20} type Toggle labeltype SYMBOL_LABEL
         }
         Fl_Button {} {
           label {@-12}
           user_data FL_ALIGN_BOTTOM
           callback align_cb
           tooltip {Places label on the bottom of the widget}
-          xywh {325 100 20 20} type Toggle labeltype SYMBOL_LABEL
+          xywh {315 65 20 20} type Toggle labeltype SYMBOL_LABEL
         }
         Fl_Button {} {
           label {@-3square}
           user_data FL_ALIGN_INSIDE
           callback align_cb
           tooltip {Places label inside the widget}
-          xywh {345 100 20 20} type Toggle labeltype SYMBOL_LABEL
+          xywh {335 65 20 20} type Toggle labeltype SYMBOL_LABEL
         }
         Fl_Value_Input widget_x {
           label {X:}
-          callback x_cb selected
+          callback x_cb
           tooltip {The x coordinate of the widget.}
-          xywh {90 135 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
+          xywh {80 100 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
         }
         Fl_Value_Input widget_y {
           label {Y:}
-          callback y_cb selected
+          callback y_cb
           tooltip {The y coordinate of the widget.}
-          xywh {145 135 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
+          xywh {135 100 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
         }
         Fl_Value_Input widget_width {
           label {Width:}
-          callback width_cb selected
+          callback width_cb
           tooltip {The width of the widget.}
-          xywh {200 135 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
+          xywh {190 100 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
         }
         Fl_Value_Input widget_height {
           label {Height:}
-          callback height_cb selected
+          callback height_cb
           tooltip {The height of the widget.}
-          xywh {255 135 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
+          xywh {245 100 55 25} align 5 labelsize 10 maximum 2000 step 1 value 10
         }
         Fl_Light_Button set_xy {
           label {Set xy}
-          callback set_xy_cb selected
+          callback set_xy_cb
           tooltip {Determines if a window is initially set to a given position.}
-          xywh {310 135 55 25} labelsize 10
+          xywh {300 100 55 25} labelsize 10
         }
         Fl_Input {} {
           label {X Class:}
           callback xclass_cb
           tooltip {The X class name which should be used for this widget.  This can be used to choose icons.}
-          xywh {90 165 95 25} when 1
+          xywh {80 130 95 25} when 1
         }
         Fl_Light_Button {} {
           label Border
           callback border_cb
           tooltip {Enable the window manager border}
-          xywh {185 165 55 25} labelsize 10
+          xywh {175 130 55 25} labelsize 10
         }
         Fl_Light_Button {} {
           label Modal
           callback modal_cb
           tooltip {This window will stay on top of others in the
 application and will prevent events from going to other windows.}
-          xywh {240 165 55 25} labelsize 10
+          xywh {230 130 55 25} labelsize 10
         }
         Fl_Light_Button {} {
           label Nonmodal
           callback non_modal_cb
           tooltip {This window will stay on top of others in the application.}
-          xywh {295 165 70 25} labelsize 10
+          xywh {285 130 70 25} labelsize 10
         }
         Fl_Value_Input {} {
           label {Value:}
           callback value_cb
           tooltip {The initial value (integer) of this widget}
-          xywh {90 170 53 20} align 4101 hide labelsize 10
+          xywh {80 135 53 20} align 4101 hide labelsize 10
         }
         Fl_Value_Input {} {
           label {Minimum:}
           callback min_cb
           tooltip {The minimum value for this valuator}
-          xywh {143 170 53 20} align 4101 hide labelsize 10
+          xywh {133 135 53 20} align 4101 hide labelsize 10
         }
         Fl_Value_Input {} {
           label {Maximum:}
           callback max_cb
           tooltip {The maximum value for this valuator}
-          xywh {196 170 53 20} align 4101 hide labelsize 10 value 1
+          xywh {186 135 53 20} align 4101 hide labelsize 10 value 1
         }
         Fl_Value_Input {} {
           label {Size:}
           callback slider_size_cb
           tooltip {The size of the scroller}
-          xywh {249 170 53 20} align 4101 hide labelsize 10
+          xywh {239 135 53 20} align 4101 hide labelsize 10
         }
         Fl_Value_Input {} {
           label {Step:}
           callback step_cb
           tooltip {Amount to change this valuator when mouse moves 1 pixel}
-          xywh {302 170 63 20} align 4101 hide labelsize 10
+          xywh {292 135 63 20} align 4101 hide labelsize 10
         }
         Fl_Group {} {
           label {Attributes:}
           callback propagate_group open
-          xywh {90 190 275 25} align 4
+          xywh {80 155 275 25} align 4
         } {
           Fl_Light_Button {} {
             label Visible
             callback visible_cb
             tooltip {Determines whether the widget is initially visible}
-            xywh {90 190 70 25} labelsize 10
+            xywh {0 0 70 25} labelsize 10
           }
           Fl_Light_Button {} {
             label Active
             callback active_cb
             tooltip {Determines whether the widget is initially active (enabled)}
-            xywh {160 190 65 25} labelsize 10
+            xywh {70 0 65 25} labelsize 10
           }
           Fl_Light_Button {} {
             label Resizable
             callback resizable_cb
             tooltip {If on, this widget and all it's parents are resizable.  When the parent resizes it moves/resizes all it's children so that this widget's edges remain the same distance from all four sides of the parent.  If this is off this widget will not resize, unless it overlaps a resizable sibling.}
-            xywh {225 190 70 25} when 1 labelsize 10
+            xywh {135 0 70 25} when 1 labelsize 10
           }
           Fl_Light_Button {} {
             label Hotspot
             callback hotspot_cb
             tooltip {Positions the window so this widget is under the mouse.  This is done when show() is called.}
-            xywh {295 190 70 25} when 1 labelsize 10
+            xywh {205 0 70 25} when 1 labelsize 10
           }
         }
         Fl_Button {} {
           label {Shortcut:}
           callback shortcut_in_cb
           tooltip {To set a shortcut click here, then type the key combination you want.  To delete the shortcut type backspace.  To stop setting the shortcut click the mouse on some other field.}
-          xywh {90 215 275 25} align 524292
+          xywh {80 180 275 25} align 524292
           code0 {\#include "Shortcut_Button.h"}
           class Shortcut_Button
         }
@@ -233,23 +233,23 @@
           label {Tooltip:}
           callback tooltip_cb
           tooltip {The pop up tooltip which should be used for the widget.}
-          xywh {90 240 275 80} type Multiline
+          xywh {80 205 275 80} type Multiline
         }
         Fl_Box {} {
           label resizable
-          xywh {90 240 275 80} hide deactivate resizable
+          xywh {80 205 275 80} hide deactivate resizable
         }
       }
       Fl_Group {} {
         label Style
         callback propagate_group
-        xywh {10 35 365 295} hide
+        xywh {0 25 365 295} hide
       } {
         Fl_Choice {} {
           label {Box:}
           callback box_cb
           tooltip {Type of box to draw around the widget (or the raised parts such as buttons of a complex widget)}
-          xywh {95 45 270 25}
+          xywh {85 10 270 25}
           code0 {extern Fl_Menu_Item boxmenu[];}
           code1 {o->menu(boxmenu);}
         } {}
@@ -257,7 +257,7 @@
           label {Text Box:}
           callback text_box_cb
           tooltip {Type of box to draw around a text display or other sunken area of the widget.}
-          xywh {95 70 270 25}
+          xywh {85 35 270 25}
           code0 {extern Fl_Menu_Item boxmenu[];}
           code1 {o->menu(boxmenu);}
         } {}
@@ -265,7 +265,7 @@
           label {Label Type:}
           callback labeltype_cb
           tooltip {How to draw the label}
-          xywh {95 95 270 25}
+          xywh {85 60 270 25}
           code0 {extern Fl_Menu_Item labeltypemenu[];}
           code1 {o->menu(labeltypemenu);}
         } {}
@@ -273,177 +273,177 @@
           label {Label Font:}
           callback labelfont_cb
           tooltip {Font to use for the label}
-          xywh {95 120 215 25}
+          xywh {85 85 215 25}
           code0 {extern Fl_Menu_Item fontmenu[];}
           code1 {o->menu(fontmenu);}
         } {}
         Fl_Value_Input {} {
           callback labelsize_cb
           tooltip {Size of the font to use for the label}
-          xywh {310 120 55 25} maximum 100 step 1 value 14
+          xywh {300 85 55 25} maximum 100 step 1 value 14
         }
         Fl_Choice {} {
           label {Text Font:}
           callback textfont_cb
           tooltip {Font to use for text displayed inside the widget}
-          xywh {95 145 215 25}
+          xywh {85 110 215 25}
           code0 {extern Fl_Menu_Item fontmenu[];}
           code1 {o->menu(fontmenu);}
         } {}
         Fl_Value_Input {} {
           callback textsize_cb
           tooltip {Size of the font to use for text displayed inside the widget}
-          xywh {310 145 55 25} maximum 100 step 1 value 14
+          xywh {300 110 55 25} maximum 100 step 1 value 14
         }
         Fl_Light_Button {} {
           label Color
           callback color_cb
           tooltip {Color of the widget (or of raised parts such as buttons of a complex widget)}
-          xywh {95 180 135 25} labelsize 10
+          xywh {85 145 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Light_Button {} {
           label {Label Color}
           callback labelcolor_cb
           tooltip {Color to draw the label}
-          xywh {230 180 135 25} labelsize 10
+          xywh {220 145 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Light_Button {} {
           label {Highlight Color}
           callback highlightcolor_cb
           tooltip {Color to use to draw the widget highlighted.  Use color zero (the black top-left chip in the color chooser) to disable highlighting.}
-          xywh {95 205 135 25} labelsize 10
+          xywh {85 170 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Light_Button {} {
           label {Highlight Label Color}
           callback highlight_label_color_cb
           tooltip {Color to draw the label when the widget is highlighted.  Use color zero (the black top-left chip in the color chooser) to leave the label colors unchanged.}
-          xywh {230 205 135 25} labelsize 10
+          xywh {220 170 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Box {} {
           label {Colors:}
-          xywh {30 220 63 20} align 24
+          xywh {20 185 63 20} align 24
         }
         Fl_Light_Button {} {
           label {Window Color}
           callback color3_cb
           tooltip {Color to draw a text display or other sunken area.}
-          xywh {95 230 135 25} labelsize 10
+          xywh {85 195 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Light_Button {} {
           label {Text Color}
           callback textcolor_cb
           tooltip {Color to draw text displayed inside the widget}
-          xywh {230 230 135 25} labelsize 10
+          xywh {220 195 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Light_Button {} {
           label {Selection Color}
           callback color2_cb
           tooltip {Color to draw behind selected text, or to color in buttons that are turned on.}
-          xywh {95 255 135 25} labelsize 10
+          xywh {85 220 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Light_Button {} {
           label {Selected Text Color}
           callback selected_textcolor_cb
           tooltip {Color to draw selected text inside the widget}
-          xywh {230 255 135 25} labelsize 10
+          xywh {220 220 135 25} labelsize 10
           code0 {o->type(0);}
         }
         Fl_Box {} {
           label resizable
-          xywh {95 180 270 100} hide deactivate resizable
+          xywh {85 145 270 100} hide deactivate resizable
         }
         Fl_Button {} {
           label {Reset to default}
           callback default_cb
           tooltip {Resets the style to this widget's default values}
-          xywh {95 295 124 25}
+          xywh {85 260 124 25}
         }
       }
       Fl_Group {} {
         label {C++}
         callback propagate_group open
-        xywh {10 35 365 295} hide
+        xywh {0 25 365 295} hide
       } {
         Fl_Input {} {
           label {Class:}
           user_data 4
           callback subclass_cb
           tooltip {This allows you to name a user-defined class that this widget is an instance of, rather than an fltk built-in class. You will need to add a \#include declaration so that the definition of your class is included in the fluid output.}
-          xywh {90 45 170 25} when 1
+          xywh {80 10 170 25} when 1 textfont 4
         }
         Fl_Choice {} {
           callback subtype_cb
           tooltip {Selects a value for type() for this widget}
-          xywh {260 45 105 25}
+          xywh {250 10 105 25}
         } {}
         Fl_Input {} {
           label {Name:}
           callback name_cb
           tooltip {The variable or member name in which to store a pointer to this widget.}
-          xywh {90 70 220 25} when 1
+          xywh {80 35 220 25} when 1 textfont 4
         }
         Fl_Light_Button {} {
           label public
           callback name_public_cb
           tooltip {Make the variable public}
-          xywh {310 70 55 25} when 1 labelsize 10
+          xywh {300 35 55 25} when 1 labelsize 10
         }
         Fl_Input {v_input[0]} {
           label {Extra Code:}
           user_data 0
           callback v_input_cb
           tooltip {Extra code to be exectuted when the widget is created}
-          xywh {90 95 275 25}
+          xywh {80 60 275 25} textfont 4
         }
         Fl_Input {v_input[1]} {
           user_data 1
           callback v_input_cb
           tooltip {Extra code to be exectuted when the widget is created}
-          xywh {90 120 275 25}
+          xywh {80 85 275 25} textfont 4
         }
         Fl_Input {v_input[2]} {
           user_data 2
           callback v_input_cb
           tooltip {Extra code to be exectuted when the widget is created}
-          xywh {90 145 275 25}
+          xywh {80 110 275 25} textfont 4
         }
         Fl_Input {v_input[3]} {
           user_data 3
           callback v_input_cb
           tooltip {Extra code to be exectuted when the widget is created}
-          xywh {90 170 275 25}
+          xywh {80 135 275 25} textfont 4
         }
         Fl_Box callback_label {
           label {Callback:}
-          xywh {20 195 70 20} align 24
+          xywh {10 160 70 20} align 24
         }
         Fl_Input {} {
           callback callback_cb
           tooltip {The name of the callback function, or code body of the callback function}
-          xywh {90 195 275 80} type Multiline
+          xywh {80 160 275 80} type Multiline textfont 4
         }
         Fl_Box {} {
           label resizable
-          xywh {90 200 165 65} hide deactivate resizable
+          xywh {80 165 165 65} hide deactivate resizable
         }
         Fl_Input {} {
           label {User Data:}
           callback user_data_cb
           tooltip {Value passed as the second argument to the callback.  This must be of the type given below.}
-          xywh {90 275 130 25}
+          xywh {80 240 130 25} textfont 4
         }
         Fl_Choice {} {
           label {When:}
           callback when_cb
           tooltip {What actions cause the callback to be called.}
-          xywh {255 275 110 25} when 0 labelsize 10
+          xywh {245 240 110 25} when 0 labelsize 10
           code0 {extern Fl_Menu_Item whenmenu[];}
           code1 {o->menu(whenmenu);}
         } {}
@@ -451,13 +451,13 @@
           label {Type:}
           callback user_data_type_cb
           tooltip {Type of the user data (must \\"long\\" or a pointer type)}
-          xywh {90 300 130 25}
+          xywh {80 265 130 25} textfont 4
         }
         Fl_Light_Button {} {
           label {no change}
           callback when_button_cb
           tooltip {Further modifies When so that the callback is done even if the widget's value has not changed.}
-          xywh {255 300 110 25} when 0 labelsize 10
+          xywh {245 265 110 25} when 0 labelsize 10
         }
       }
     }
@@ -468,7 +468,7 @@
         label {&Overlays}
         callback overlay_cb
         tooltip {Turns overlays (red outlines)  of the selected  widgets on or off}
-        xywh {95 340 90 25}
+        xywh {0 0 90 25}
         code0 {extern int overlays_invisible;}
         code1 {o->value(!overlays_invisible);}
       }
@@ -476,12 +476,12 @@
         label OK
         callback ok_cb
         tooltip {Closes this attribute window}
-        xywh {225 340 65 25} shortcut 0xff0d
+        xywh {130 0 65 25} shortcut 0xff0d
       }
       Fl_Button {} {
         label Cancel
         callback cancel_cb
-        xywh {300 340 70 25}
+        xywh {205 0 70 25}
       }
     }
   }
diff -Nru ./src/Fl_Browser.cxx ../fltk-2-cvs/src/Fl_Browser.cxx
--- ./src/Fl_Browser.cxx	Thu Mar 22 22:18:27 2001
+++ ../fltk-2-cvs/src/Fl_Browser.cxx	Tue Jul 10 20:00:12 2001
@@ -359,8 +359,8 @@
       fl_rectf(X, y+1, W, h-2);
       fl_color(c0 <= FL_LIGHT1 ? c1 : Fl_Color(FL_LIGHT1));
       //fl_color(fl_color_average(c1, c0, 1.9));
-      fl_xyline(X, y, X+W);
-      fl_xyline(X, y+h-1, X+W);
+      fl_line(X, y, X+W, y);
+      fl_line(X, y+h-1, X+W, y+h-1);
     } else {
       fl_color(c0);
       fl_rectf(X, y, W, h);
diff -Nru ./src/Fl_Choice.cxx ../fltk-2-cvs/src/Fl_Choice.cxx
--- ./src/Fl_Choice.cxx	Thu Mar  8 09:39:05 2001
+++ ../fltk-2-cvs/src/Fl_Choice.cxx	Tue Jul 10 20:00:12 2001
@@ -28,7 +28,7 @@
 #include <FL/fl_draw.H>
 
 // Set this to 1 for "classic fltk" rather than Windows style:
-#define MOTIF_STYLE 1
+#define MOTIF_STYLE 0
 
 // The dimensions for the glyph in this and the Fl_Menu_Button are exactly
 // the same, so that glyphs may be shared between them.
diff -Nru ./src/Fl_Item.cxx ../fltk-2-cvs/src/Fl_Item.cxx
--- ./src/Fl_Item.cxx	Thu Mar 22 22:18:27 2001
+++ ../fltk-2-cvs/src/Fl_Item.cxx	Tue Jul 10 20:00:12 2001
@@ -81,7 +81,7 @@
 	int i = 0;
 	while(column_widths()[i])
 	{
-	  char hold;
+	  char hold = 0;
 	  int cw = column_widths()[i];
 	  char *pTemp = pRemainder;
 	  pRemainder = strchr(pTemp, column_char());
diff -Nru ./src/Fl_Menu.cxx ../fltk-2-cvs/src/Fl_Menu.cxx
--- ./src/Fl_Menu.cxx	Tue Jul 10 11:14:38 2001
+++ ../fltk-2-cvs/src/Fl_Menu.cxx	Tue Jul 10 20:00:12 2001
@@ -57,6 +57,9 @@
 // behind the events.  This communication is unfortunately extremely
 // messy.
 
+#define MENU_PAD_LEFT  8
+#define MENU_PAD_RIGHT 8
+
 #define MAX_LEVELS 30
 
 class MenuWindow;
@@ -259,6 +262,10 @@
   }
 
   int dh = box->dh();
+  
+  W+=MENU_PAD_LEFT;
+  W+=MENU_PAD_RIGHT;
+  
   x(X); w(W); h(H + dh);
   if (selected >= 0) Y += Hp/2-selected_y-box->dy(); else Y += Hp;
   y(Y); // if !group: else {y(Y-2); w(1); h(1);}
@@ -310,7 +317,9 @@
 
 void MenuWindow::draw() {
   if (damage() != FL_DAMAGE_CHILD) box()->draw(this,0,0,w(),h(),0);
-  int x=0; int y=0; int w=this->w(); int h=0; box()->inset(x,y,w,h);
+  int x=0;   
+  int y=0; int w=this->w(); int h=0; box()->inset(x,y,w,h);
+  
   int selected = level <= menustate->level ? menustate->indexes[level] : -1;
   int leading = menustate->widget->leading(); // +2 ?
   for (int i = 0; ; i++) {
@@ -339,9 +348,10 @@
 	}
       }
       if (!widget->active_r()) flags |= FL_INACTIVE;
-      fl_x_ = x;
+      fl_x_ = x+MENU_PAD_LEFT;
       fl_y_ = y+leading/2;
-      int save_w = widget->w(); widget->w(w);
+      int save_w = widget->w(); widget->w(w-MENU_PAD_LEFT-MENU_PAD_RIGHT);
+
       widget->draw();
       widget->w(save_w);
       Fl::pushed_ = 0;
@@ -350,12 +360,13 @@
       if (is_parent(i)) {
 	// Use the item's fontsize for the size of the arrow, rather than h:
         int nh = fl_height(widget->label_font(), widget->label_size());
-        draw_glyph(FL_GLYPH_RIGHT, x+w-nh, y+(ih-nh)/2, nh, nh, flags);
+        int nh2 = nh/2;
+        draw_glyph(FL_GLYPH_RIGHT, x+w-nh+(nh2/2), y+(ih-nh2)/2, nh2, nh2, flags);
       } else if (widget->shortcut()) {
         Fl_Color c = widget->get_label_color(flags);
         //fl_font(widget->text_font(), widget->text_size());
 	widget->label_type()->draw(Fl::key_name(widget->shortcut()),
-				   x, y, w-3, ih, c, flags | FL_ALIGN_RIGHT);
+				   x+MENU_PAD_LEFT, y, w-3-MENU_PAD_RIGHT-MENU_PAD_LEFT, ih, c, flags | FL_ALIGN_RIGHT);
       }
     }
     y += ih;
diff -Nru ./src/Fl_Slider.cxx ../fltk-2-cvs/src/Fl_Slider.cxx
--- ./src/Fl_Slider.cxx	Wed Feb 21 08:15:44 2001
+++ ../fltk-2-cvs/src/Fl_Slider.cxx	Tue Jul 10 20:00:12 2001
@@ -38,12 +38,6 @@
   } else if (type() == FL_HOR_NICE_SLIDER) {
     FL_THIN_DOWN_BOX->draw(x, y+h/2-2, w, 4, fl_inactive(FL_BLACK, f), f);
   }
-  if (focused()) {
-    fl_color(FL_BLACK);
-    fl_line_style(FL_DOT);
-    fl_rect(x+1,y+1,w-2,h-2);
-    fl_line_style(0);
-  }
 }
 
 // Return how big the slider should be if area is of size WxH:
@@ -95,12 +89,12 @@
   }
 
   if (X > 0) {
-    if (horizontal()) draw_bg(x, y, X, h, f);
-    else draw_bg(x, y, w, X, f);
+    if (horizontal()) draw_bg(x, y, X+1, h, f);
+    else draw_bg(x, y, w, X+1, f);
   }
   if (X+S < W) {
-    if (horizontal()) draw_bg(x+X+S, y, w-X-S, h, f);
-    else draw_bg(x, y+X+S, w, h-X-S, f);
+    if (horizontal()) draw_bg(x+X+S-1, y, w-X-S+1, h, f);
+    else draw_bg(x, y+X+S-1, w, h-X-S+1, f);
   }
 
   // Sigh. Special case for "nice" sliders
@@ -109,14 +103,38 @@
     if (type() == FL_HOR_NICE_SLIDER) g = FL_GLYPH_HNSLIDER;
     else if (type() == FL_HOR_FILL_SLIDER) g = 0;
     else g = FL_GLYPH_HSLIDER;
+    
+    if (!focused()) {
+    
     draw_glyph(g, x+X, y, S, h, f);
+    
+    } else {
+      draw_glyph(g, x+X+1, y+1, S-2, h-2, f);
+      fl_color(fl_contrast(FL_BLACK, color()));
+      fl_line_style(FL_SOLID);
+      fl_rect(x+X,y,S,h);
+      fl_line_style(0);
+    }
+    
     draw_inside_label(x+X, y, S, h, f);
   } else {
     int g;
     if (type() == FL_VERT_NICE_SLIDER) g = FL_GLYPH_VNSLIDER;
     else if (type() == FL_VERT_FILL_SLIDER) g = 0;
     else g = FL_GLYPH_VSLIDER;
+
+    if (!focused()) {
+    
     draw_glyph(g, x, y+X, w, S, f);
+
+    } else {
+      draw_glyph(g, x+1, y+X+1, w-2, S-2, f);
+      fl_color(fl_contrast(FL_BLACK, color()));
+      fl_line_style(FL_SOLID);
+      fl_rect(x,y+X,w,S);
+      fl_line_style(0);
+    }
+    
     draw_inside_label(x, y+X, w, S, f);
   }
 }
diff -Nru ./src/Fl_Tabs.cxx ../fltk-2-cvs/src/Fl_Tabs.cxx
--- ./src/Fl_Tabs.cxx	Tue Feb 20 08:59:50 2001
+++ ../fltk-2-cvs/src/Fl_Tabs.cxx	Tue Jul 10 20:00:12 2001
@@ -37,6 +37,8 @@
 #define TABSLOPE 5
 #define EXTRASPACE 5
 
+extern void __focus_rectangle(int x, int y, int w, int h, Fl_Color c);
+
 // return the left edges of each tab (plus a fake left edge for a tab
 // past the right-hand one).  These position are actually of the left
 // edge of the slope.  They are either seperated by the correct distance
@@ -366,12 +368,13 @@
   }
   if (W > TABSLOPE+EXTRASPACE/2) {
     if (sel && focused()) {
-      fl_color(FL_BLACK);
-      fl_line_style(FL_DOT);
-      fl_rect(x2-W+TABSLOPE,
-	      (H<0?h()+H-3:0)+1, W-TABSLOPE,
-	      (H<0?-H:H)+1);
-      fl_line_style(0);
+      
+      __focus_rectangle(x2-W+TABSLOPE,
+                        (H<0?h()+H-3:0)+2,
+                        W-TABSLOPE+1,
+                        (H<0?-H:H)-1,
+                        color());
+                         
     }
     o->draw_label((what==LEFT ? x1 : x2-W)+(TABSLOPE+EXTRASPACE/2),
 		  (H<0?h()+H-2:0), W-(TABSLOPE+EXTRASPACE/2),
